﻿; _____________________________________________________________________________
; ¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯
; »»» Project  : MySQL_Wrapper
; »»» Author   : Bisonte
; »»» Version  : 2.0
; »»» Compiler : PureBasic 5.00 (Windows - x86)
; »»» created  : 09.11.2012 - 12:31
; »»» Flags    : [ ]ASM       [ ]Unicode  [x]Thread  [x]XP-Skin
; »»»            [ ]AdminMode [ ]Usermode [ ]OnError [ ]Purifier
; _____________________________________________________________________________
; ¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯
EnableExplicit
;
;{ »» MySQL Init
#CLIENT_MULTI_STATEMENTS = 65536
Enumeration ;enum_field_types
  #MYSQL_TYPE_DECIMAL         ;DECIMAL- oder NUMERIC-Feld
  #MYSQL_TYPE_TINY            ;TINYINT-Feld
  #MYSQL_TYPE_SHORT           ;SMALLINT-Feld
  #MYSQL_TYPE_LONG            ;INTEGER-Feld
  #MYSQL_TYPE_FLOAT           ;FLOAT-Feld
  #MYSQL_TYPE_DOUBLE          ;DOUBLE- oder REAL-Feld
  #MYSQL_TYPE_NULL            ;Feld mit NULL-Typ
  #MYSQL_TYPE_TIMESTAMP       ;TIMESTAMP-Feld
  #MYSQL_TYPE_LONGLONG        ;BIGINT-Feld
  #MYSQL_TYPE_INT24           ;MEDIUMINT-Feld
  #MYSQL_TYPE_DATE            ;DATE-Feld
  #MYSQL_TYPE_TIME            ;TIME-Feld
  #MYSQL_TYPE_DATETIME        ;DATETIME-Feld
  #MYSQL_TYPE_YEAR            ;YEAR-Feld
  #MYSQL_TYPE_NEWDATE         ;DATETIME-Feld
  #MYSQL_TYPE_VARCHAR         ;VARCHAR
  #MYSQL_TYPE_BIT             ;BIT-Feld
  #MYSQL_TYPE_NEWDECIMAL=246  ;DECIMAL- oder NUMERIC-Typ für Präzisionsberechnungen
  #MYSQL_TYPE_ENUM=247        ;ENUM-Feld
  #MYSQL_TYPE_SET=248         ;SET-Feld
  #MYSQL_TYPE_TINY_BLOB=249   ;TINYTEXT
  #MYSQL_TYPE_MEDIUM_BLOB=250 ;MEDIUMTEXT
  #MYSQL_TYPE_LONG_BLOB=251   ;LONGTEXT
  #MYSQL_TYPE_BLOB=252        ;BLOB- oder TEXT-Feld (die Maximallänge wird mit max_length ermittelt)
  #MYSQL_TYPE_VAR_STRING=253  ;VARCHAR- oder VARBINARY-Feld
  #MYSQL_TYPE_STRING=254      ;CHAR- oder BINARY-Feld
  #MYSQL_TYPE_GEOMETRY=255    ;Feld eines raumbezogenen Typs
  #MAX_NO_FIELD_TYPES ;/* Should always be last */
EndEnumeration
Structure MYSQL
EndStructure
Structure MYSQL_RES
EndStructure
Structure MYSQL_BIND
EndStructure
Structure MYSQL_STMT
EndStructure
;
Structure MYSQL_ROW
  *field[255]
EndStructure
Structure MYSQL_FIELD
  name.s
  org_name.s
  table.s
  org_table.s
  db.s
  catalog.s
  def.s
  length.l
  max_length.l
  name_length.l
  org_name_length.l
  table_length.l
  org_table_length.l
  db_length.l
  catalog_length.l
  def_length.l
  flags.l
  decimals.l
  charset_nr.l
  type.l
EndStructure
Structure MY_CHARSET_INFO
  number.l
  state.l
  csname.s
  name.s
  Comment.s
  dir.s
  mbminlen.l
  mbmaxlen.l
EndStructure
Structure MYSQL_FIELDARRAY
  field.MYSQL_FIELD[0]
EndStructure
Structure MYSQL_LONGARRAY
  long.i[0]
EndStructure
;
Import "libmysql.lib"
  
  ; ** Start Prototypes **
  
  ; Function : mysql_get_client_info()
  ; Usage    : PeekS(mysql_get_client_info())
  ; Desc     : Returns Pointer to Version STRING of Mysql Client
  mysql_get_client_info()
  
  ; Function : mysql_get_client_version()
  ; Usage    : Result.l = mysql_get_client_version()
  ; Desc     : Returns Versionnumber as LONG of Mysql Client
  mysql_get_client_version()
  
  ; Function : mysql_errno()
  ; Usage    : Result.l = mysql_get_client_info(*MySQLHandle)
  ; Desc     : Returns Error No as LONG
  mysql_errno(*mysql.MYSQL)
  
  ; Function : mysql_init()
  ; Usage    : *MySQLHandle = mysql_init(#Null)
  ; Desc     : Returns MySQL DB Handle as LONG
  mysql_init(*mysql.MYSQL)
  
  ; Function : mysql_real_connect(*mysql.MYSQL,host.p-utf8,user.p-utf8,passwd.p-utf8,db.p-utf8,port.l,unix_socket.p-utf8,client_flag.l)
  ; Usage    : Result.l = mysql_real_connect(*mysql.MYSQL,host.p-utf8,user.p-utf8,passwd.p-utf8,db.p-utf8,port.l,unix_socket.p-utf8,client_flag.l)
  ; Desc     :
  mysql_real_connect(*mysql.MYSQL,host.p-utf8,user.p-utf8,passwd.p-utf8,db.p-utf8,port.l,unix_socket.p-utf8,client_flag.l)
  
  ; Function : mysql_get_parameters()
  ; Usage    : debug Hex(mysql_get_parameters())
  ; Desc     :
  mysql_get_parameters()
  
  ; Function : mysql_sqlstate()
  ; Usage    : State.p-utf8 = PeekS(mysql_sqlstate(*MySQLHandle))
  ; Desc     :
  mysql_sqlstate(*mysql.MYSQL)
  
  ; Function : mysql_error()
  ; Usage    : PeekS(mysql_error(*MySQLHandle))
  ; Desc     : Returns Pointer as LONG to ErrormessageString
  mysql_error(*mysql.MYSQL)
  
  ; Function : mysql_get_server_version()
  ; Usage    : Result.l = mysql_get_server_version(*MySQLHandle)
  ; Desc     : Returns LONG from ServerVersion
  mysql_get_server_version(*mysql.MYSQL)
  
  ; Function : mysql_get_server_info()
  ; Usage    : PeekS(mysql_get_server_info(*MySQLHandle))
  ; Desc     : Returns Pointer as LONG to ServerInfoString
  mysql_get_server_info(*mysql.MYSQL)
  
  ; Function : mysql_get_host_info()
  ; Usage    : PeekS(mysql_get_host_info(*MySQLHandle))
  ; Desc     : Returns Pointer as LONG to HostInfoString / Connectioninfo
  mysql_get_host_info(*mysql.MYSQL)
  
  ; Function : mysql_select_db()
  ; Usage    : mysql_select_db(*MySQLHandle, Databasename.p-utf8)
  ; Desc     : Selects current Database
  mysql_select_db(*mysql.MYSQL, Databasename.p-utf8)
  
  ; Function : mysql_get_proto_info()
  ; Usage    : Result.l = mysql_get_proto_info(*MySQLHandle))
  ; Desc     :
  mysql_get_proto_info(*mysql.MYSQL)
  
  ; Function : mysql_info()
  ; Usage    : Result.l = mysql_info(*MySQLHandle))
  ; Desc     :
  mysql_info(*mysql.MYSQL)
  
  ; Function : mysql_insert_id()
  ; Usage    : Result.l = mysql_insert_id(*MySQLHandle))
  ; Desc     : Returns Inserted ID as LONG
  mysql_insert_id(*mysql.MYSQL)
  
  ; Function : mysql_affected_rows()
  ; Usage    : Result.l = mysql_affected_rows(*MySQLHandle))
  ; Desc     :
  mysql_affected_rows(*mysql.MYSQL)
  
  ; Function : mysql_autocommit()
  ; Usage    : mysql_autocommit(*MySQLHandle,#Bool) ; #True / #False
  ; Desc     :
  mysql_autocommit(*mysql.MYSQL,*mode.Byte)
  
  ; Function : mysql_character_set_name()
  ; Usage    : mysql_character_set_name(*MySQLHandle)
  ; Desc     :
  mysql_character_set_name(*mysql.MYSQL)
  
  ; Function : mysql_close()
  ; Usage    : mysql_close(*MySQLHandle)
  ; Desc     : Closes the MySQL Connection
  mysql_close(*mysql.MYSQL)
  
  ; Function : mysql_commit()
  ; Usage    : mysql_commit(*MySQLHandle)
  ; Desc     :
  mysql_commit(*mysql.MYSQL)
  
  ; Function : mysql_debug()
  ; Usage    : mysql_debug(DebugString.p-utf8)
  ; Desc     :
  mysql_debug(DebugString.p-utf8)
  
  ; Function : mysql_disable_reads_from_master()
  ; Usage    : mysql_disable_reads_from_master(*MySQLHandle)
  ; Desc     :
  mysql_disable_reads_from_master(*mysql.MYSQL)
  
  ; Function : mysql_disable_rpl_parse()
  ; Usage    : mysql_disable_rpl_parse(*MySQLHandle)
  ; Desc     :
  mysql_disable_rpl_parse(*mysql.MYSQL)
  
  ; Function : mysql_dumPB_debug_info()
  ; Usage    : mysql_dumPB_debug_info(*MySQLHandle)
  ; Desc     :
  mysql_dumPB_debug_info(*mysql.MYSQL)
  
  ; Function : mysql_embedded()
  ; Usage    : mysql_embedded()
  ; Desc     :
  mysql_embedded()
  
  ; Function : mysql_enable_reads_from_master()
  ; Usage    : mysql_enable_reads_from_master(*MySQLHandle)
  ; Desc     :
  mysql_enable_reads_from_master(*mysql.MYSQL)
  
  ; Function : mysql_enable_rpl_parse()
  ; Usage    : mysql_enable_rpl_parse(*MySQLHandle)
  ; Desc     :
  mysql_enable_rpl_parse(*mysql.MYSQL)
  
  ; Function : mysql_field_count()
  ; Usage    : mysql_field_count(*MySQLHandle)
  ; Desc     :
  mysql_field_count(*mysql.MYSQL)
  
  ; Function : mysql_library_end()
  ; Usage    : mysql_library_end(*MySQLHandle)
  ; Desc     :
  mysql_library_end(*mysql.MYSQL)
  
  ; Function : mysql_list_processes()
  ; Usage    : mysql_list_processes(*MySQLHandle)
  ; Desc     :
  mysql_list_processes(*mysql.MYSQL)
  
  ; Function : mysql_more_results()
  ; Usage    : mysql_more_results(*MySQLHandle)
  ; Desc     :
  mysql_more_results(*mysql.MYSQL)
  
  ; Function : mysql_next_result()
  ; Usage    : mysql_next_result(*MySQLHandle)
  ; Desc     :
  mysql_next_result(*mysql.MYSQL)
  
  ; Function : mysql_ping()
  ; Usage    : mysql_ping(*MySQLHandle)
  ; Desc     :
  mysql_ping(*mysql.MYSQL)
  
  ; Function : mysql_read_query_result()
  ; Usage    : mysql_read_query_result(*MySQLHandle)
  ; Desc     :
  mysql_read_query_result(*mysql.MYSQL)
  
  ; Function : mysql_reload()
  ; Usage    : mysql_reload(*MySQLHandle)
  ; Desc     :
  mysql_reload(*mysql.MYSQL)
  
  ; Function : mysql_rollback()
  ; Usage    : mysql_rollback(*MySQLHandle)
  ; Desc     :
  mysql_rollback(*mysql.MYSQL)
  
  ; Function : mysql_rpl_parse_enabled()
  ; Usage    : mysql_rpl_parse_enabled(*MySQLHandle)
  ; Desc     :
  mysql_rpl_parse_enabled(*mysql.MYSQL)
  
  ; Function : mysql_rpl_probe()
  ; Usage    : mysql_rpl_probe(*MySQLHandle)
  ; Desc     :
  mysql_rpl_probe(*mysql.MYSQL)
  
  ; Function : mysql_server_end()
  ; Usage    : mysql_server_end()
  ; Desc     :
  mysql_server_end()
  
  ; Function : mysql_thread_end()
  ; Usage    : mysql_thread_end()
  ; Desc     :
  mysql_thread_end()
  
  ; Function : mysql_thread_init()
  ; Usage    : mysql_thread_init()
  ; Desc     :
  mysql_thread_init()
  
  ; Function : mysql_thread_safe()
  ; Usage    : mysql_thread_safe()
  ; Desc     :
  mysql_thread_safe()
  
  ; Function : mysql_stat()
  ; Usage    : mysql_stat(*MySQLHandle)
  ; Desc     :
  mysql_stat(*mysql.MYSQL)
  
  ; Function : mysql_store_result()
  ; Usage    : *MySQLResult = mysql_store_result(*MySQLHandle)
  ; Desc     :
  mysql_store_result(*mysql.MYSQL)
  
  ; Function : mysql_thread_id()
  ; Usage    : Result.l = mysql_thread_id(*MySQLHandle)
  ; Desc     :
  mysql_thread_id(*mysql.MYSQL)
  
  ; Function : mysql_use_result()
  ; Usage    : mysql_use_result(*MySQLHandle)
  ; Desc     :
  mysql_use_result(*mysql.MYSQL)
  
  ; Function : mysql_warning_count()
  ; Usage    : mysql_warning_count(*MySQLHandle)
  ; Desc     :
  mysql_warning_count(*mysql.MYSQL)
  
  ; Function : mysql_change_user()
  ; Usage    : mysql_change_user(*MySQLHandle, user.p-utf8, passwd.p-utf8, db.p-utf8)
  ; Desc     :
  mysql_change_user(*mysql.MYSQL,user.p-utf8,passwd.p-utf8,db.p-utf8)
  
  ; Function : mysql_data_seek()
  ; Usage    : mysql_data_seek(*MySQLResult, offset.d)
  ; Desc     :
  mysql_data_seek(*result.MYSQL_RES,offset.d)
  
  ; Function : mysql_eof()
  ; Usage    : mysql_eof(*MySQLResult)
  ; Desc     :
  mysql_eof(*result.MYSQL_RES)
  
  ; Function : mysql_escape_string()
  ; Usage    : mysql_escape_string(strTo.p-utf8, strFrom.p-utf8, length.l)
  ; Desc     :
  mysql_escape_string(strTo.p-utf8,strFrom.p-utf8,length.l)
  
  ; Function : mysql_fetch_field()
  ; Usage    : *field.MYSQL_FIELD = mysql_fetch_field(*MySQLResult)
  ; Desc     :
  mysql_fetch_field(*result.MYSQL_RES)
  
  ; Function : mysql_fetch_field_direct()
  ; Usage    : *field.MYSQL_FIELD = mysql_fetch_field_direct(*MySQLResult, fieldnr.l)
  ; Desc     :
  mysql_fetch_field_direct(*result.MYSQL_RES,fieldnr.l)
  
  ; Function : mysql_fetch_fields()
  ; Usage    : *fieldArray.MYSQL_FIELD = mysql_fetch_fields(*MySQLResult)
  ; Desc     :
  mysql_fetch_fields(*result.MYSQL_RES)
  
  ; Function : mysql_fetch_lengths()
  ; Usage    : mysql_fetch_lengths(*MySQLResult)
  ; Desc     :
  mysql_fetch_lengths(*result.MYSQL_RES)
  
  ; Function : mysql_fetch_row()
  ; Usage    : *row.MYSQL_ROW = mysql_fetch_row(*MySQLResult)
  ; Desc     :
  mysql_fetch_row(*result.MYSQL_RES)
  
  ; Function : mysql_field_seek()
  ; Usage    : mysql_field_seek(*MySQLResult, offset.l)
  ; Desc     :
  mysql_field_seek(*result.MYSQL_RES,offset.l)
  
  ; Function : mysql_field_tell()
  ; Usage    : mysql_field_tell(*MySQLResult)
  ; Desc     :
  mysql_field_tell(*result.MYSQL_RES)
  
  ; Function : mysql_free_result()
  ; Usage    : mysql_free_result(*MySQLResult)
  ; Desc     :
  mysql_free_result(*result.MYSQL_RES)
  
  ; Function : mysql_get_character_set_info()
  ; Usage    : mysql_get_character_set_info(*MySQLResult, *MySQL_CharsetInfo)
  ; Desc     :
  mysql_get_character_set_info(*mysql.MYSQL,*cs.MY_CHARSET_INFO)
  
  ; Function : mysql_hex_string()
  ; Usage    : mysql_hex_string(strTo.p-utf8, strFrom.p-utf8, length.l)
  ; Desc     :
  mysql_hex_string(strTo.p-utf8,strFrom.p-utf8,length.l)
  
  ; Function : mysql_kill()
  ; Usage    : mysql_kill(*MySQLHandle, pid.l)
  ; Desc     :
  mysql_kill(*mysql.MYSQL,pid.l)
  
  ; Function : mysql_library_init()
  ; Usage    : mysql_library_init(argc.l, argv.l, groups.l)
  ; Desc     :
  mysql_library_init(argc.l,argv.l,Groups.l)
  
  ; Function : mysql_list_dbs()
  ; Usage    : mysql_list_dbs(*MySQLHandle, Wildcard.p-utf8)
  ; Desc     :
  mysql_list_dbs(*mysql.MYSQL,wild.p-utf8)
  
  ; Function : mysql_list_fields()
  ; Usage    : mysql_list_fields(*MySQLHandle, Table.p-utf8, Wildcard.p-utf8)
  ; Desc     :
  mysql_list_fields(*mysql.MYSQL,table.p-utf8,wild.p-utf8)
  
  ; Function : mysql_list_tables()
  ; Usage    : mysql_list_tables(*MySQLHandle, Wildcard.p-utf8)
  ; Desc     :
  mysql_list_tables(*mysql.MYSQL,wild.p-utf8)
  
  ; Function : mysql_master_query()
  ; Usage    : mysql_master_query(*MySQLHandle, query.p-utf8, length.l)
  ; Desc     :
  mysql_master_query(*mysql.MYSQL,query.p-utf8,length.l)
  
  ; Function : mysql_num_fields()
  ; Usage    : Result.l = mysql_num_fields(*MySQLResult)
  ; Desc     :
  mysql_num_fields(*result.MYSQL_RES)
  
  ; Function : mysql_num_rows()
  ; Usage    : Result.l = mysql_num_rows(*MySQLResult)
  ; Desc     :
  mysql_num_rows(*result.MYSQL_RES)
  
  ; Function : mysql_options()
  ; Usage    : Result.l = mysql_options(*MySQLHandle, option.l, arg.p-utf8)
  ; Desc     :
  mysql_options(*mysql.MYSQL,option.l,arg.p-utf8)
  
  ; Function : mysql_query()
  ; Usage    : Result.l = mysql_query(*MySQLHandle, query.p-utf8)
  ; Desc     :
  mysql_query(*mysql.MYSQL,query.p-utf8)
  
  ; Function : mysql_real_escape_string()
  ; Usage    : mysql_real_escape_string(*MySQLHandle, strTo.p-utf8, strFrom.p-utf8, length.l)
  ; Desc     :
  mysql_real_escape_string(*mysql.MYSQL,strTo.p-utf8,strFrom.p-utf8,length.l)
  
  ; Function : mysql_real_query()
  ; Usage    : *MySQLResult = mysql_real_query(*MySQLHandle, query.p-utf8, length.l)
  ; Desc     :
  mysql_real_query(*mysql.MYSQL,query.p-utf8,length.l)
  
  ; Function : mysql_refresh()
  ; Usage    : mysql_refresh(*MySQLHandle, options.l)
  ; Desc     :
  mysql_refresh(*mysql.MYSQL,Options.l)
  
  ; Function : mysql_row_seek()
  ; Usage    : mysql_row_seek(*MySQLHandle, offset.l)
  ; Desc     :
  mysql_row_seek(*mysql.MYSQL,offset.l)
  
  ; Function : mysql_row_tell()
  ; Usage    : mysql_row_tell(*MySQLResult)
  ; Desc     :
  mysql_row_tell(*result.MYSQL_RES)
  
  ; Function : mysql_rpl_query_type()
  ; Usage    : mysql_rpl_query_type(*MySQLHandle, type.l)
  ; Desc     :
  mysql_rpl_query_type(*mysql.MYSQL,type.l)
  
  ; Function : mysql_send_query()
  ; Usage    : mysql_send_query(*MySQLHandle, query.p-utf8, length.l)
  ; Desc     :
  mysql_send_query(*mysql.MYSQL,query.p-utf8,length.l)
  
  ; Function : mysql_server_init()
  ; Usage    : mysql_server_init(argc.l, argv.l, groups.l)
  ; Desc     :
  mysql_server_init(argc.l,argv.l,Groups.l)
  
  ; Function : mysql_set_character_set()
  ; Usage    : mysql_set_character_set(*MySQLHandle, csname.p-utf8)
  ; Desc     :
  mysql_set_character_set(*mysql.MYSQL,csname.p-utf8)
  
  ; Function : mysql_set_server_option()
  ; Usage    : mysql_set_server_option(*MySQLHandle, option.l)
  ; Desc     :
  mysql_set_server_option(*mysql.MYSQL,option.l)
  
  ; Function : mysql_shutdown()
  ; Usage    : mysql_shutdown(*MySQLHandle, shutdown_level.l)
  ; Desc     :
  mysql_shutdown(*mysql.MYSQL,shutdown_level.l)
  
  ; Function : mysql_slave_query()
  ; Usage    : mysql_slave_query(*MySQLHandle, query.p-utf8, length.l)
  ; Desc     :
  mysql_slave_query(*mysql.MYSQL,query.p-utf8,length.l)
  
  ; Function : mysql_ssl_set()
  ; Usage    : mysql_ssl_set(*MySQLHandle, key.p-utf8, cert.p-utf8, ca.p-utf8, capath.p-utf8, cipher.p-utf8)
  ; Desc     :
  mysql_ssl_set(*mysql.MYSQL,key.p-utf8,cert.p-utf8,ca.p-utf8,capath.p-utf8,cipher.p-utf8)
  
EndImport
;
Procedure.s PeekS_Utf8(*buffer);also checks if buffer is valid, returns an empty string if *buffer is 0
  If *buffer
    ProcedureReturn PeekS(*buffer, -1, #PB_Ascii)
  Else
    ProcedureReturn ""
  EndIf
EndProcedure
;
;}
;{ »» MySQL Init PB
Structure struct_mysql_databases
  
  ID.i
  Host.s
  User.s
  Pass.s
  Port.i
  Name.s
  
  hDB.i
  
  Result.i
  
  rRows.i
  rFields.i
  
  RowNr.i
  
  List blobparams.s()
  
EndStructure

Global NewList __MySQL_DB.struct_mysql_databases()

Procedure mIsDataBase(ID)
  Protected Flag = #False
  ForEach __MySQL_DB()
    If __MySQL_DB()\ID = ID
      Flag = #True
      Break
    EndIf
  Next
  ProcedureReturn Flag
EndProcedure
Procedure mGetDataBaseID(ID)
  
  If mIsDataBase(ID)
    ProcedureReturn __MySQL_DB()\hDB
  EndIf
  
  ProcedureReturn #False
  
EndProcedure
Procedure mCloseDataBase(ID)
  
  If mIsDataBase(ID)
    mysql_close(__MySQL_DB()\hDB)
    DeleteElement(__MySQL_DB())
    ProcedureReturn #True  
  EndIf
  ProcedureReturn #False
  
EndProcedure
Procedure mOpenDataBase(ID, Database.s, User.s, Pass.s, Host.s = "localhost", Port = 3306)
  
  Protected hdb
  
  If LCase(Host) = "localhost" : Host = "127.0.0.1" : EndIf
  
  If ID = #PB_Any
    ID = ListSize(__MySQL_DB()) + 1
  Else
    If mIsDataBase(ID)
      mCloseDataBase(ID)
    EndIf
  EndIf
  
  hdb = mysql_init(#Null)
  
  If mysql_real_connect(hdb, Host, User, Pass, "", Port, #NULL$, #CLIENT_MULTI_STATEMENTS)
    mysql_autocommit(hdb, #True)
    If mysql_select_db(hdb, Database) <> 1
      AddElement(__MySQL_DB())
      With __MySQL_DB()
        \hDB = hdb : \Host = Host : \ID = ID : \Name = Database : \Pass = Pass : \Port = Port
        \Result = 0 : \rFields = 0 : \rRows = 0 : \RowNr = -1 : \User = User
      EndWith
      ProcedureReturn ID
    EndIf
    mysql_close(hdb)
  Else
    MessageRequester("MySQL Error",PeekS(mysql_error(hdb), -1, #PB_UTF8))
  EndIf
  
EndProcedure

Procedure mDataBaseQuery(ID, SQL.s)
  
  Protected hdb, rvar, i
  
  If mIsDataBase(ID)
    
    hdb = __MySQL_DB()\hDB
    
    If ListSize(__MySQL_DB()\blobparams()) > 0
      For i = 0 To ListSize(__MySQL_DB()\blobparams()) - 1
        SelectElement(__MySQL_DB()\blobparams(), i)
        ReplaceString(SQL, "$" + Str(i), __MySQL_DB()\blobparams())
      Next
      ClearList(__MySQL_DB()\blobparams())
    EndIf
    
    rvar = mysql_real_query(hdb, SQL, Len(SQL))
    If rvar = 0
      __MySQL_DB()\Result = mysql_store_result(hdb)
      If __MySQL_DB()\Result
        __MySQL_DB()\rFields = mysql_fetch_fields(__MySQL_DB()\Result)
        __MySQL_DB()\RowNr = -1
        ProcedureReturn #True
      EndIf
    EndIf
        
  EndIf
  MessageRequester("MySQL Error",PeekS(mysql_error(hdb), -1, #PB_UTF8))
  ProcedureReturn #False
  
EndProcedure
Procedure mDataBaseUpdate(ID, SQL.s)
  
  Protected i, rvar
  
  If mIsDataBase(ID)
  
    If ListSize(__MySQL_DB()\blobparams()) > 0
      For i = 0 To ListSize(__MySQL_DB()\blobparams()) - 1
        SelectElement(__MySQL_DB()\blobparams(), i)
        ReplaceString(SQL, "$" + Str(i), __MySQL_DB()\blobparams())
      Next
      ClearList(__MySQL_DB()\blobparams())
    EndIf
    
    rvar = mysql_real_query(__MySQL_DB()\hDB, SQL, Len(SQL))
    If rvar = 0
      ProcedureReturn mysql_affected_rows(__MySQL_DB()\hDB)
    EndIf  
  EndIf
  ProcedureReturn #False  
EndProcedure
Procedure mNextDataBaseRow(ID)
  
  If mIsDataBase(ID)
    
    __MySQL_DB()\RowNr + 1
    __MySQL_DB()\rRows = mysql_fetch_row(__MySQL_DB()\Result)
    
    ProcedureReturn __MySQL_DB()\rRows
    
  EndIf
  ProcedureReturn #False
  
EndProcedure
Procedure mPreviousDataBaseRow(ID)
EndProcedure
Procedure mFinishDataBaseQuery(ID)
  
  If mIsDataBase(ID)
    mysql_free_result(__MySQL_DB()\Result)
    __MySQL_DB()\Result = #False
  EndIf
  
EndProcedure
Procedure mDatabaseColumnType(ID, Field)
  
  Protected *fields.MYSQL_FIELDARRAY, numFields
  
  If mIsDataBase(ID)
      *fields = __MySQL_DB()\rFields    
      numFields = mysql_num_fields(__MySQL_DB()\Result)
      If Field < numFields
        
        Select *fields\field[Field]\type
          Case #MYSQL_TYPE_TINY, #MYSQL_TYPE_SHORT, #MYSQL_TYPE_LONG, #MYSQL_TYPE_NULL, #MYSQL_TYPE_TIMESTAMP, #MYSQL_TYPE_YEAR, #MYSQL_TYPE_BIT, #MYSQL_TYPE_ENUM
            ProcedureReturn #PB_Database_Long
          Case #MYSQL_TYPE_DATE, #MYSQL_TYPE_TIME, #MYSQL_TYPE_DATETIME, #MYSQL_TYPE_NEWDATE, #MYSQL_TYPE_VARCHAR, #MYSQL_TYPE_SET, #MYSQL_TYPE_GEOMETRY
            ProcedureReturn #PB_Database_String
          Case #MYSQL_TYPE_FLOAT
            ProcedureReturn #PB_Database_Float
          Case #MYSQL_TYPE_DECIMAL, #MYSQL_TYPE_DOUBLE, #MYSQL_TYPE_NEWDECIMAL
            ProcedureReturn #PB_Database_Double
          Case #MYSQL_TYPE_LONGLONG, #MYSQL_TYPE_INT24
            ProcedureReturn #PB_Database_Quad
          Case #MYSQL_TYPE_TINY_BLOB, #MYSQL_TYPE_MEDIUM_BLOB, #MYSQL_TYPE_LONG_BLOB, #MYSQL_TYPE_BLOB, #MYSQL_TYPE_VAR_STRING, #MYSQL_TYPE_STRING
            ProcedureReturn #PB_Database_Blob
          Default
            ProcedureReturn #PB_Database_Long
        EndSelect
                
      EndIf
    EndIf

  
EndProcedure
Procedure.s mGetDataBaseString(ID, Field)
  
  Protected *row.MYSQL_ROW
  
  If mIsDataBase(ID)
    If Field < 255
      *row = __MySQL_DB()\rRows
      If *row
        ProcedureReturn PeekS_Utf8(*row\field[Field])
      EndIf
    EndIf    
  EndIf
  ProcedureReturn ""
  
EndProcedure
Procedure.l mGetDataBaseLong(ID, Field)
  
  Protected Erg.s = mGetDataBaseString(ID, Field)
  
  If mDatabaseColumnType(ID, Field) = #PB_Database_Long
    ProcedureReturn Val(mGetDataBaseString(ID, Field))
  EndIf
  ProcedureReturn 0
  
EndProcedure
Procedure.d mGetDataBaseDouble(ID, Field)
  
  Protected Erg.s = mGetDataBaseString(ID, Field)
  
  If mDatabaseColumnType(ID, Field) = #PB_Database_Double
    ProcedureReturn ValD(mGetDataBaseString(ID, Field))
  EndIf
  ProcedureReturn 0
  
EndProcedure
Procedure.q mGetDataBaseQuad(ID, Field)
  Protected Erg.s = mGetDataBaseString(ID, Field)
  
  If mDatabaseColumnType(ID, Field) = #PB_Database_Quad
    ProcedureReturn Val(mGetDataBaseString(ID, Field))
  EndIf
  ProcedureReturn 0
  
EndProcedure
Procedure.f mGetDataBaseFloat(ID, Field)
  Protected Erg.s = mGetDataBaseString(ID, Field)
  
  If mDatabaseColumnType(ID, Field) = #PB_Database_Float
    ProcedureReturn ValF(mGetDataBaseString(ID, Field))
  EndIf
  ProcedureReturn 0
EndProcedure
Procedure MYSQL_DatabaseColumnSize(ID, Field)
  
  Protected *sizes.MYSQL_LONGARRAY
  Protected numfields
  
  If mIsDataBase(ID)
    numfields = mysql_num_fields(__MySQL_DB()\Result)
    If Field < numfields
      *sizes = mysql_fetch_lengths(__MySQL_DB()\Result)
      If *sizes
        ProcedureReturn *sizes\long[Field]
      EndIf
    EndIf
  EndIf
  ProcedureReturn #False
    
EndProcedure

; Eselsbrücken zur SQL Syntax:
; Ein INSERT
; "INSERT INTO `core_users` (`index`, `name_first`) VALUES (NULL, 'saaGoing');"
; Ein UPDATE
; "UPDATE `core_users` SET `name_first` = 'hugu' WHERE `index`=7;"
; Ein DELETE
; "DELETE FROM `core_users` WHERE `index`=7;"
; Ein SELECT alles
; "SELECT * FROM `core_users`"
; Ein SELECT nur bestimmte Felder
; "SELECT `index`,`name_first` FROM `core_users`"
;}
;
; ; »»» Demo
;
; Define OOD, oob
; 
; OOD = mOpenDataBase(#PB_Any, "characters", "username", "passwort")
; OOB = mOpenDataBase(#PB_Any, "rwdb", "username", "passwort")
;
; If OOD
;   If mDataBaseQuery(OOD, "SELECT * FROM characters")
;     Debug "Query"
;     While mNextDataBaseRow(OOD)
;       Debug mGetDataBaseString(OOD, 2)
;     Wend
;     mFinishDataBaseQuery(OOD)
;   EndIf
; EndIf
; DisableExplicit

; If OOB
;   
;   SQL.s = "INSERT INTO `core_users` (`index`, `name_first`) VALUES (NULL, 'saaGoing');"
;   tt = mDataBaseUpdate(OOB, SQL)
;     Debug "upQuery"
;     Debug tt
;     mFinishDataBaseQuery(OOB)
; EndIf

; 
; mCloseDataBase(OOD)
; mCloseDataBase(OOB)
; IDE Options = PureBasic 5.00 (Windows - x86)
; CursorPosition = 813
; FirstLine = 5
; Folding = AACAC9
; EnableThread
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 66
; EnableBuildCount = 0
; EnableExeConstant